import org.teavm.helper.HTMLConsoleElement;
import org.teavm.helper.ScanMainMethods;
import org.teavm.jso.browser.Window;
import org.teavm.jso.dom.html.HTMLButtonElement;
import org.teavm.jso.dom.html.HTMLDocument;
import org.teavm.jso.dom.html.HTMLElement;
import org.teavm.jso.dom.xml.NodeList;

public class Register {

	private static void registerJavaRunButtons() {
		final Window window = Window.current();
		HTMLDocument document = window.getDocument();
		@SuppressWarnings("unchecked")
		NodeList<? extends HTMLButtonElement> javaRunBtns = 
				(NodeList<? extends HTMLButtonElement>) document.querySelectorAll("button.run.java[data-main]");
		for (int i = 0; i < javaRunBtns.getLength(); i++) {
			HTMLButtonElement button = javaRunBtns.item(i);
			String main = button.getAttribute("data-main");
			String ouputId = javaRunBtns.item(i).getAttribute("data-output");
			ouputId = ouputId != null ? ouputId : main;
			HTMLElement output = document.getElementById(ouputId);
			button.addEventListener("click",
				event -> HTMLConsoleElement.runMain(button, output, args -> ScanMainMethods.runMainMethod(main, args), new String[] {})
			);
			if (button.getInnerHTML().matches("^\\s*$"))
				button.setInnerHTML("java " + main);
		}
	}

	public static void main(String[] args) {
		registerJavaRunButtons();
		// ensure Double.doubleValue is not stripped
		Double.valueOf(0).doubleValue();
	}

}
