// START CUSTOM HPCC-JS/WASM GRAPHVIZ INTEGRATION
var graphviz = window["@hpcc-js/wasm"].graphviz;

function allGraphvizToSVG() {
                var graphs = document.querySelectorAll( 'pre.viz, script[type="text/vnd.graphviz"]' );
                return Promise.allSettled(Array.prototype.map.call(graphs, graphvizToSVG));
            }

function graphvizToSVG(element) {
                        if (element.parentNode === null) {
                          console.error('parentNode is null for', element);
                          throw new Error('parentNode is null');
                        }

                        var graph = element.innerHTML;
                        graph = graph
                                  .replace(/&lt;/g,"<")
                                  .replace(/&gt;/g,">")
                                  .replace(/<\/?tbody>/gi,"")
                                  .replace(/<br>/gi,"<br/>")
                                  .replace(/<br([^>/]+)>/gi,"<br$1/>");
                        //// Now escape html unless prevented by author
                        //if( ! element.hasAttribute( 'data-noescape' )) {
                        //        element.innerHTML = element.innerHTML.replace(/</g,"&lt;").replace(/>/g,"&gt;");
                        //}

                        return graphviz.layout(graph, 'svg', element.hasAttribute('data-engine')?element.getAttribute('data-engine'):'dot')
                              .then(function(svgString) {
                                  var parser = new DOMParser();
                                  var svg = parser.parseFromString(svgString, "image/svg+xml").documentElement;
                                  // copy attributes
                                  for (var i=0; i<element.attributes.length; i++)
                                    if (!svg.hasAttribute(element.attributes[i].name))
                                      svg.setAttribute(element.attributes[i].name,element.attributes[i].value);
                                  // replace pre with svg in document
                                  element.parentNode.replaceChild(svg, element);
                              })
                              .catch(err => {
                                  var err_elt = document.createElement('div');
                                  err_elt.classList.add('error');
                                  err_elt.innerText = err;
                                  var err_eltp = document.createElement('pre');
                                  var err_eltc = document.createElement('code');
                                  err_eltc.innerText = graph;
                                  err_eltp.appendChild(err_eltc);
                                  err_elt.appendChild(err_eltp);
                                  element.parentNode.replaceChild(err_elt, element);
                              });
                }
// END CUSTOM HPCC-JS/WASM GRAPHVIZ INTEGRATION
// REQUIRE @hpcc-js/wasm
